/* eslint-disable */
<template>
  <v-row justify="center" no-gutters>
    <v-card style="width: 100%; user-select: none;">
      <v-card-text class="px-4 mt-n5">
        <v-form ref="form">
          <v-container>
            <v-row no-gutters>
              <v-col cols="12" class="mt-n1">
                <v-text-field
                  autofocus
                  v-model="reply.title"
                  label="Título"
                  prepend-icon="mdi-pencil-box-outline"
                ></v-text-field>
              </v-col>
              <v-col cols="12" style="position: relative">
                <p style="padding-bottom: 5px">Mensagem:</p>
                <editor-menu-bar :editor="editor" v-slot="{ commands, isActive }">
                  <div>
                    <!-- Negrito -->
                    <v-tooltip bottom nudge-bottom="-8">
                      <template v-slot:activator="{ on }">
                        <button
                          type="button"
                          v-on="on"
                          class="menubar__button"
                          :class="{ 'is-active': isActive.bold() }"
                          @click="commands.bold"
                        >
                          <v-icon
                            :class="isActive.bold() ? 'menuBarSelected' : 'menuBarNot'"
                            :color="isActive.bold() ? 'primary' : 'secondary'"
                            >mdi-format-bold</v-icon
                          >
                        </button>
                      </template>
                      <span>Negrito</span>
                    </v-tooltip>
                    <!-- Italico -->
                    <v-tooltip bottom nudge-bottom="-8">
                      <template v-slot:activator="{ on }">
                        <button
                          type="button"
                          v-on="on"
                          class="menubar__button"
                          :class="{ 'is-active': isActive.italic() }"
                          @click="commands.italic"
                        >
                          <v-icon
                            :class="isActive.italic() ? 'menuBarSelected' : 'menuBarNot'"
                            :color="isActive.italic() ? 'primary' : 'secondary'"
                            >mdi-format-italic</v-icon
                          >
                        </button>
                      </template>
                      <span>Itálico</span>
                    </v-tooltip>
                    <!-- Underline -->
                    <v-tooltip bottom nudge-bottom="-8">
                      <template v-slot:activator="{ on }">
                        <button
                          type="button"
                          v-on="on"
                          class="menubar__button"
                          :class="{ 'is-active': isActive.underline() }"
                          @click="commands.underline"
                        >
                          <v-icon
                            :class="isActive.underline() ? 'menuBarSelected' : 'menuBarNot'"
                            :color="isActive.underline() ? 'primary' : 'secondary'"
                            >mdi-format-underline</v-icon
                          >
                        </button>
                      </template>
                      <span>Sublinhar</span>
                    </v-tooltip>
                    <!-- Riscar -->
                    <v-tooltip bottom nudge-bottom="-8">
                      <template v-slot:activator="{ on }">
                        <button
                          type="button"
                          v-on="on"
                          class="menubar__button"
                          :class="{ 'is-active': isActive.strike() }"
                          @click="commands.strike"
                        >
                          <v-icon
                            :class="isActive.strike() ? 'menuBarSelected' : 'menuBarNot'"
                            :color="isActive.strike() ? 'primary' : 'secondary'"
                            >mdi-format-strikethrough</v-icon
                          >
                        </button>
                      </template>
                      <span>Riscar</span>
                    </v-tooltip>

                    <!-- Heading1 -->
                    <v-tooltip bottom nudge-bottom="-8">
                      <template v-slot:activator="{ on }">
                        <button
                          type="button"
                          v-on="on"
                          class="menubar__button"
                          :class="{ 'is-active': isActive.heading({ level: 1 }) }"
                          @click="commands.heading({ level: 1 })"
                        >
                          <v-icon
                            :class="
                              isActive.heading({ level: 1 }) ? 'menuBarSelected' : 'menuBarNot'
                            "
                            :color="isActive.heading({ level: 1 }) ? 'primary' : 'secondary'"
                            >mdi-format-header-1</v-icon
                          >
                        </button>
                      </template>
                      <span>Cabeçalho H1</span>
                    </v-tooltip>
                    <!-- Heading2 -->
                    <v-tooltip bottom nudge-bottom="-8">
                      <template v-slot:activator="{ on }">
                        <button
                          type="button"
                          v-on="on"
                          class="menubar__button"
                          :class="{ 'is-active': isActive.heading({ level: 2 }) }"
                          @click="commands.heading({ level: 2 })"
                        >
                          <v-icon
                            :class="
                              isActive.heading({ level: 2 }) ? 'menuBarSelected' : 'menuBarNot'
                            "
                            :color="isActive.heading({ level: 2 }) ? 'primary' : 'secondary'"
                            >mdi-format-header-2</v-icon
                          >
                        </button>
                      </template>
                      <span>Cabeçalho H2</span>
                    </v-tooltip>
                    <!-- Heading3 -->
                    <v-tooltip bottom nudge-bottom="-8">
                      <template v-slot:activator="{ on }">
                        <button
                          type="button"
                          v-on="on"
                          class="menubar__button"
                          :class="{ 'is-active': isActive.heading({ level: 3 }) }"
                          @click="commands.heading({ level: 3 })"
                        >
                          <v-icon
                            :class="
                              isActive.heading({ level: 3 }) ? 'menuBarSelected' : 'menuBarNot'
                            "
                            :color="isActive.heading({ level: 3 }) ? 'primary' : 'secondary'"
                            >mdi-format-header-3</v-icon
                          >
                        </button>
                      </template>
                      <span>Cabeçalho H3</span>
                    </v-tooltip>
                    <!-- BulletList -->
                    <v-tooltip bottom nudge-bottom="-8">
                      <template v-slot:activator="{ on }">
                        <button
                          type="button"
                          v-on="on"
                          class="menubar__button"
                          :class="{ 'is-active': isActive.bullet_list() }"
                          @click="commands.bullet_list"
                        >
                          <v-icon
                            :class="isActive.bullet_list() ? 'menuBarSelected' : 'menuBarNot'"
                            :color="isActive.bullet_list() ? 'primary' : 'secondary'"
                            >mdi-format-list-bulleted</v-icon
                          >
                        </button>
                      </template>
                      <span>Lista</span>
                    </v-tooltip>
                    <!-- OrderedList -->
                    <v-tooltip bottom nudge-bottom="-8">
                      <template v-slot:activator="{ on }">
                        <button
                          type="button"
                          v-on="on"
                          class="menubar__button"
                          :class="{ 'is-active': isActive.ordered_list() }"
                          @click="commands.ordered_list"
                        >
                          <v-icon
                            :class="isActive.ordered_list() ? 'menuBarSelected' : 'menuBarNot'"
                            :color="isActive.ordered_list() ? 'primary' : 'secondary'"
                            >mdi-format-list-numbered</v-icon
                          >
                        </button>
                      </template>
                      <span>Lista Numérica</span>
                    </v-tooltip>
                    <!-- Link -->

                    <v-dialog v-model="linkMenuIsActive" persistent width="450px">
                      <dialog-url
                        @closeUrlDialog="linkMenuIsActive = false"
                        @linkUrl="linkUrlChanged"
                      />
                    </v-dialog>
                    <v-tooltip bottom nudge-bottom="-8">
                      <template v-slot:activator="{ on }">
                        <button
                          type="button"
                          v-on="on"
                          class="menubar__button"
                          :class="{ 'is-active': isActive.link() }"
                          @click="openLinkUrl(commands.link, isActive.link())"
                        >
                          <v-icon
                            :class="isActive.link() ? 'menuBarSelected' : 'menuBarNot'"
                            :color="isActive.link() ? 'primary' : 'secondary'"
                            >mdi-link-variant</v-icon
                          >
                        </button>
                      </template>
                      <section style="text-align: center;">
                        Adicionar Link
                        <br />
                        <div style="font-size:0.7rem; margin-top: -8px">
                          (Selecione o texto e click)
                        </div>
                      </section>
                    </v-tooltip>
                  </div>
                </editor-menu-bar>
                <editor-content
                  id="editor-box"
                  class="editor-box"
                  :editor="editor"
                  v-model="editor.content"
                />

                <div v-if="addEditMode === 'edit'">
                  <v-checkbox v-model="reply.public" label="Público"></v-checkbox>
                </div>
                <!-- AddEdit Mode -> Trabalho Colaborativo -->
                <div
                  v-if="addEditMode === 'add' || addEditMode === 'edit'"
                  style="position: relative"
                >
                  <v-expansion-panels v-model="advanced" flat>
                    <v-expansion-panel class="elevation-0">
                      <v-expansion-panel-header style="width: 180px" class="pl-3 pr-0">
                        <v-row class="secondary--text" justify="start">
                          <v-icon class="mr-2" color="secondary" small>mdi-cog</v-icon
                          ><b>Opções Avançadas</b>
                        </v-row></v-expansion-panel-header
                      >

                      <v-expansion-panel-content>
                        <v-row no-gutters style="margin-left: 7%">
                          <v-col cols="12" class="mt-n1">
                            <b>Número de participantes por grupo:</b>
                            <div class="mt-4" style="display: flex">
                              <v-icon class="pb-6 pr-2">mdi-account-group</v-icon>
                              <v-select
                                style="max-width: 140px; min-width: 140px"
                                v-model="reply.maxPerTeam"
                                :items="[1, 2, 3, 4, 5, 6, 8, 9, 10]"
                                label="Participantes"
                                dense
                                outlined
                                flat
                              ></v-select>
                            </div>
                          </v-col>
                          <SelectData
                            :icon="'mdi-calendar'"
                            :title="'Data Inicial para disponibilizar'"
                            :toUpdate="editInitVisibilityDate"
                            @selectedDateDone="updateAvailableInitialDate"
                          />
                          <SelectData
                            :icon="'mdi-calendar-export'"
                            :toUpdate="editEndVisibilityDate"
                            :title="'Data Final para disponibilizar'"
                            @selectedDateDone="updateAvailableEndDate"
                          />
                          <SelectData
                            :icon="'mdi-calendar-edit'"
                            :title="'Data Inicial para responder'"
                            :toUpdate="editInitialDate"
                            @selectedDateDone="updateAnswerInitialDate"
                          />
                          <SelectData
                            :icon="'mdi-calendar-multiple-check'"
                            :title="'Data Final para responder'"
                            :toUpdate="editEndDate"
                            @selectedDateDone="updateAnswerEndDate"
                          />
                        </v-row>
                      </v-expansion-panel-content>
                    </v-expansion-panel>
                  </v-expansion-panels>
                </div>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <div
          v-if="addEditMode == 'answer'"
          class="ml-2 mt-n5"
          style="display: flex; align-items: center"
        >
          <v-icon class="pr-1">mdi-paperclip</v-icon><b>Anexo: </b>
          <v-file-input
            style="max-width: 240px"
            class="ml-3 mt-5"
            v-model="reply.file"
            prepend-icon=""
            dense
            label="Selecionar arquivo"
            accept="image/png, image/jpeg, image/bmp, application/pdf, application/xls, application/xml, application/pptx, application/ppt"
            outlined
          />
        </div>
      </v-card-text>
      <v-card-actions class="mt-n7">
        <v-spacer />
        <v-btn color="lighter" text @click="handleClose">Cancelar</v-btn>
        <v-btn color="primary" elevation="0" @click="handleSubmit" :disabled="!reply.title">{{
          buttonLabel
        }}</v-btn>
      </v-card-actions>
    </v-card>
  </v-row>
</template>

<script>
import { Editor, EditorContent, EditorMenuBar } from 'tiptap'
import {
  OrderedList,
  BulletList,
  ListItem,
  Bold,
  Italic,
  Link,
  Strike,
  Underline,
  Heading,
} from 'tiptap-extensions'
import DialogUrl from './FormatedMessageUrl.vue'
import SelectData from './SelectData.vue'

export default {
  name: 'FormatedMessage',
  components: {
    DialogUrl,
    EditorContent,
    EditorMenuBar,
    SelectData,
  },
  props: {
    buttonLabel: { type: String, default: 'Salvar' },
    //editing para o editar respostas
    editing: {
      type: Object,
      default: () => {
        return {}
      },
    },
    addEditMode: { type: String, default: 'empty' },
    itemToEdit: {
      type: Object,
      default: () => {
        return {}
      },
    },
  },
  computed: {
    cleanAdvancedCollaborativeWork() {
      return this.$store.state.user.cleanAdvancedCollaborativeWork
    },
  },

  data: () => ({
    //tiptap plugin
    editor: new Editor({
      content: '',
      extensions: [
        new Bold(),
        new Italic(),
        new Strike(),
        new Underline(),
        new Link(),
        new Heading({ levels: [1, 2, 3] }),
        new ListItem(),
        new BulletList(),
        new OrderedList(),
      ],
    }),
    linkCommand: null,
    linkMenuIsActive: false,
    reply: {
      title: '',
      message: '',
      initVisibilityDate: '',
      endVisibilityDate: '',
      initialDate: '',
      endDate: '',
      public: null,
      maxPerTeam: '',
      file: null,
    },
    editInitVisibilityDate: null,
    editEndVisibilityDate: null,
    editInitialDate: null,
    editEndDate: null,
    advanced: null,
    cleanAvailableInitialDate: 0,
  }),
  watch: {
    cleanAdvancedCollaborativeWork() {
      this.advanced = null
      this.cleanData()
    },
    'itemToEdit.id'() {
      this.loadEditInfoCollaborativeWork()
    },
  },
  beforeDestroy() {
    this.editor.destroy()
  },
  created() {
    // para editar msgs enviadas apartir da lista de respostas (ReadReply.vue)
    if (this.editing.answers) this.reply.title = this.editing.answers[0].title
    if (this.editing.answers) this.editor.setContent(this.editing.answers[0].comment)
    // fim
    this.loadEditInfoCollaborativeWork()
  },
  methods: {
    loadEditInfoCollaborativeWork() {
      if (this.addEditMode == 'edit') {
        this.reply.title = this.itemToEdit.name
        this.editor.setContent(this.itemToEdit.description)

        if (this.itemToEdit.initVisibilityDate)
          this.editInitVisibilityDate = this.itemToEdit.initVisibilityDate

        if (this.itemToEdit.endVisibilityDate)
          this.editEndVisibilityDate = this.itemToEdit.endVisibilityDate

        if (this.itemToEdit.initialDate) this.editInitialDate = this.itemToEdit.initialDate

        if (this.itemToEdit.endDate) this.editEndDate = this.itemToEdit.endDate

        this.reply.public = this.itemToEdit.public
        this.reply.maxPerTeam = this.itemToEdit.maxPerTeam
      }
    },
    cleanData() {
      this.editor.clearContent()
      this.reply = {
        title: '',
        initVisibilityDate: '',
        endVisibilityDate: '',
        initialDate: '',
        endDate: '',
        public: null,
        maxPerTeam: '',
        file: null,
      }
      this.editInitVisibilityDate = null
      this.editEndVisibilityDate = null
      this.editInitialDate = null
      this.editEndDate = null
    },
    /// Inicio métodos componente de selecionar a data
    convertDataToTimeStamp(data) {
      if (data.year && data.month && data.day && data.hour && data.minute) {
        let timeStamp = new Date(
          data.year,
          Number(data.month) - 1,
          Number(data.day),
          Number(data.hour),
          Number(data.minute)
        )
        return timeStamp.getTime()
      }
      return ''
    },
    updateAvailableInitialDate(item) {
      this.reply.initVisibilityDate = this.convertDataToTimeStamp(item)
    },
    updateAvailableEndDate(item) {
      this.reply.endVisibilityDate = this.convertDataToTimeStamp(item)
    },
    updateAnswerInitialDate(item) {
      this.reply.initialDate = this.convertDataToTimeStamp(item)
    },
    updateAnswerEndDate(item) {
      this.reply.endDate = this.convertDataToTimeStamp(item)
    },
    /// Fim métodos componente selecionar data

    ///// APENAS MÉTODOS TELA SEM INTEGRAÇÃO COM BACKEND
    //INICIO BOTAO INSERIR HYPERLINK

    openLinkUrl(command, condition) {
      //condition = se o texto selecionado tem link, retorna true.

      let checkSelected = window.getSelection().isCollapsed
      //checkSelected = false (tem algo selecionado)
      //checkSelected = true (não tem nada selecionado)

      if (!checkSelected && !condition) {
        this.linkMenuIsActive = true
        this.linkCommand = command
      } else {
        this.setLinkUrl(command, null)
      }
    },
    setLinkUrl(command, url) {
      command({ href: url })
    },
    //recebe do dialog o endereço da url
    linkUrlChanged(item) {
      this.setLinkUrl(this.linkCommand, item)
      this.linkMenuIsActive = false
    },

    //FIM BOTAO INSERIR HYPERLINK

    handleClose() {
      // limpa dados do componente Data / Opções Avançado
      this.advanced = null
      this.$store.commit(
        'user/UPDATE_CLEAN_ADVANCED_COLLABORATIVEWORK',
        this.cleanAdvancedCollaborativeWork + 1
      )
      // fim limpa dados

      this.$emit('cancelReply')
      this.cleanData()
    },
    //clica no botão de enviar
    async handleSubmit() {
      // limpa dados do componente Data / Opções Avançado
      this.advanced = null
      this.$store.commit(
        'user/UPDATE_CLEAN_ADVANCED_COLLABORATIVEWORK',
        this.cleanAdvancedCollaborativeWork + 1
      )

      // fim limpa dados

      this.reply.message = this.editor.getHTML()
      this.$emit('sendedMsg', this.reply)

      // limpa
      this.cleanData()
    },
  },
}
</script>

<style>
.attach > .v-input__control {
  display: none !important;
}
.ProseMirror {
  margin-top: 10px;
  margin-bottom: 10px;
  padding: 8px;
  color: #000;
  border: 1px solid #808080;
  border-radius: 0.2rem;
  min-height: 140px;
  max-height: 140px !important;
  overflow-y: auto;
}

.ProseMirror:focus {
  outline: none;
  border: 1px solid #2a0845 !important;
  min-height: 140px;
  max-height: 140px !important;
}

.menubar__button {
  outline: none;
  padding-right: 4px;
}

.menuBarSelected {
  background: #ccc;
  border: 1px solid #ccc;
  border-radius: 0.2rem;
  padding: 2px;
}
.menuBarNot {
  background: none;
  border: 1px solid #808080;
  border-radius: 0.2rem;
  padding: 2px;
}
p {
  margin: 0 !important;
}

ul > li > p {
  margin: 0 !important;
}

ol > li > p {
  margin: 0 !important;
}

.deleteTitleFont {
  transform: scale(0.75);
}
.iconTitle {
  padding-top: 15px;
  transform: scale(1.5);
}
.upload {
  padding-top: 15px;
  padding-bottom: 25px;
  transform: scale(1.5);
}
.sub {
  font-size: 1.3em;
}
.iconPosition {
  padding-top: 35px;
}
</style>
